import sys
import time
import math
import resource
import random
from pony import orm

orm.set_sql_debug(True)
db = orm.Database()
db.bind(provider='sqlite', filename=":memory:", create_db=True)
#db.bind(provider='sqlite', filename="test.db", create_db=True)


class Test(db.Entity):
    id = orm.PrimaryKey(int,auto=True)
    value = orm.Required(float)

db.generate_mapping(create_tables=True)

with orm.db_session:
    for i in range(10):
        Test(value=random.random())
    t = Test[5]
    print("The value of Test[5] is",t.value)
    t.value += 0.25

# split sessions

with orm.db_session:
    for i in range(10):
        Test(value=random.random())
    t = Test[5]

with orm.db_session:
    print("The value of Test[5] is",t.value)
    t = Test[t.id]
    t.value += 0.25
