import sys
import time
import math
from pony import orm

orm.set_sql_debug(True)
db = orm.Database()
db.bind(provider='sqlite', filename=":memory:", create_db=True)
#db.bind(provider='sqlite', filename="rh.db", create_db=True)

class Emp(db.Entity):
    id = orm.PrimaryKey(int,auto=True)
    name = orm.Optional(str,unique=True)
    salary = orm.Required(float,nullable=True)
    works_in = orm.Required('Dept')
    supervisor = orm.Optional('Emp')
    supervised = orm.Set('Emp')

class Dept(db.Entity):
    id = orm.PrimaryKey(int,auto=True)
    name = orm.Required(str)
    city = orm.Required(str)
    emps = orm.Set('Emp')


db.generate_mapping(create_tables=True)


with orm.db_session:
    direction = Dept(name='Direction',city='Lille')
    john = Emp(name='John',salary=30000,works_in=direction)
    alice = Emp(name='Alice',salary=45000,works_in=direction)

    orm.commit()

    management = Dept(name='Marketing',city='Paris')
    Emp(name='Paul',salary=28000,works_in=management,supervisor=john)
    Emp(name='Uma',salary=35000,works_in=management,supervisor=alice)

    orm.commit()


    e = Emp.get(name='Alice')
    print(e.id,e.name)
    e = Emp[1]
    print(e.id,e.name)

    for e in orm.select(e for e in Emp if e.salary < 30000):
        print(e.id,e.name,e.salary)

    for e in orm.select(e for e in Emp if e.salary > 30000 and e.works_in.name=='Marketing'):
        print(e.id,e.name,e.salary)
                
    
